/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2002 from the
 * contents of XSAccessor.xs. Do not edit this file, edit XSAccessor.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "XSAccessor.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"

/*
 * Quoting chocolateboy from his Method::Lexical module at 2009-02-08:
 *
 * for binary compatibility (see perlapi.h), XS modules perform a function call to
 * access each and every interpreter variable. So, for instance, an innocuous-looking
 * reference to PL_op becomes:
 *
 *     (*Perl_Iop_ptr(my_perl))
 *
 * This (obviously) impacts performance. Internally, PL_op is accessed as:
 *
 *     my_perl->Iop
 *
 * (in threaded/multiplicity builds (see intrpvar.h)), which is significantly faster.
 *
 * defining PERL_CORE gets us the fast version, at the expense of a future maintenance release
 * possibly breaking things: http://www.xray.mpe.mpg.de/mailing-lists/perl5-porters/2008-04/msg00171.html
 *
 * Rather than globally defining PERL_CORE, which pokes its fingers into various headers, exposing
 * internals we'd rather not see, just define it for XSUB.h, which includes
 * perlapi.h, which imposes the speed limit.
 */

#define PERL_CORE
#include "XSUB.h"
#undef PERL_CORE

#include "ppport.h"

#include "CXSAccessor.h"

#define CXAA(name) XS_Class__XSAccessor__Array_ ## name
#define CXAH(name) XS_Class__XSAccessor_ ## name

#define CXA_CHECK_HASH(self)                                                            \
if (!(SvROK(self) && SvTYPE(SvRV(self)) == SVt_PVHV)) {                                 \
    croak("Class::XSAccessor: invalid instance method invocant: no hash ref supplied"); \
}

#define CXA_CHECK_ARRAY(self)                                                            \
if (!(SvROK(self) && SvTYPE(SvRV(self)) == SVt_PVAV)) {                                  \
    croak("Class::XSAccessor: invalid instance method invocant: no array ref supplied"); \
}

/*
 * chocolateboy: 2009-09-06 - 2009-11-14:
 *
 * entersub ops that call our accessors are optimized (i.e. replaced with optimized versions)
 * in versions of perl >= 5.10.0. This section describes the implementation.
 *
 * TL;DR: the first time one of our fast (XS) accessors is called, we reach up into the
 * calling OP (OP_ENTERSUB) and change its implementation (PL_op->op_ppaddr) to an optimized
 * version that takes advantage of the fact that our accessors are straightforward hash/array lookups.
 * 5.10.0+ is required because earlier versions of perl lack any spare (i.e. unused) flags
 * we can use to indicate that an OP has had entersub optimization disabled. perls >= 5.10.0 have
 * a new OP member called op_spare that gives us 3 whole bits to play with!
 *
 * First, some preliminaries: a method call is performed as a subroutine call at the OP
 * level. there's some additional work to look up the method CV and push the invocant
 * on the stack, but the current OP inside a method call is the subroutine call OP, OP_ENTERSUB.
 *
 * two distinct invocations of the same method will have two entersub OPs and will receive
 * the same CV on the stack:
 *
 *     $foo->bar(...); # OP 1: CV 1
 *     $foo->bar(...); # OP 2: CV 1
 *
 * There are also situations in which the same entersub OP calls more than one CV: 
 *
 *     $foo->$_() for (foo bar); # OP 1: CV 1, CV 2
 *
 * Inside each Class::XSAccessor XSUB, we can access the current entersub OP (PL_op).
 * The default entersub implementation (pp_entersub in pp_hot.c) has a lot of boilerplate for
 * dealing with all the different ways in which subroutines can be called. It sets up
 * and tears down a new scope; it deals with the fact that the code ref can be passed
 * in as a GV or CV; and it has numerous conditional statements to deal with the various
 * different types of CV.
 *
 * For our XSUB accessors, we don't need most of that. We don't need to open a new scope;
 * the subroutine is almost always a CV (that's what OP_METHOD and OP_METHOD_NAMED usually return);
 * and we don't need to deal with all the non-XSUB cases. This allows us to replace the
 * OP's implementation (op_ppaddr) with a version optimized for our simple XSUBs. (This
 * is inspired by B::XSUB::Dumber: nothingmuch++)
 *
 * We do this inside the accessor i.e. at runtime. We can also back out the optimization
 * if a call site proves to be dynamic e.g. if a method is redefined or the method is
 * called with multiple different CVs (see below).
 *
 * in practice, this is rarely the case. the vast majority of method calls in perl,
 * and in most dynamic languages (cf. Google's v8), behave like method calls in static
 * languages. for instance, 97% of the call sites exercised by perl 5.10.0's test suite are
 * monomorphic
 *
 * We only replace the op_ppaddr pointer of entersub OPs that use the default pp_entersub.
 * this ensures we don't interfere with any modules that assign a new op_ppaddr e.g.
 * Data::Alias, Faster. it also ensures we don't tread on our own toes and repeatedly
 * re-assign the same optimized entersub
 *
 * This module provides two XSUBs for each accessor e.g. two versions of the getter/setter/predicate &c.
 * XSUBs. The first version is called <accessor_type>_init (e.g. "getter_init") and the second
 * version is called <accessor_type> e.g. "getter". The first version is assigned for
 * every new accessor by code that looks something like this:
 *
 *     INSTALL_NEW_CV_HASH_OBJ(name, CXAH(getter_init), key);
 *
 * where "name" is the name of the getter sub in perl (e.g. "foo"), key is the name of the key to look up
 * in the hash (e.g. "FOO"), and CXAH(getter_init) is the full name of the C function that
 * implements the getter - on most platforms, it's something like:
 *
 *     XS_Class__XSAccessor_getter_init 
 *
 * On VMS, the names are mangled to fit in 31 characters. So, for instance, getter_init becomes:
 *
 *     XS_Class_XSAccessor_getter_init
 *
 * (note the snipped underscore to keep the name under 32 characters).
 *
 * The XSUB with the _init suffix is the optimizing version, and the XSUB without
 * the _init suffix is the slightly faster non-optimizing version. The optimized entersub
 * does something like the following (imagine the coderef is in $cv):
 *
 *     if ($cv->xsub == CLASS_XS_ACCESSOR_GETTER_INIT) {
 *         return CLASS_XS_ACCESSOR_GETTER(@args);
 *     } # else restore the op's default entersub implementation and call that
 *
 * i.e. the optimized entersub calls the non-optimizing XSUB. There's one optimized
 * entersub for each type of Class::XSAccessor accessor. To save typing, they're
 * generated by C preprocessor macros i.e. poor man's generic programming.
 *
 * If, for some reason, the entersub should not be optimized, a flag is set on the
 * entersub OP. This flag is detected by the (default) _init accessor. If the flag is set,
 * the entersub OP will never be optimized.
 *
 * There are a number of situations in which optimization is disabled.
 *
 * 1) if the entersub is not perl's default entersub i.e. if another module has
 * provided its own entersub implementation, then we don't replace it.
 *
 * 2) if the call site is dynamic. the optimized entersub is optimized for a particular
 * type of Class::XSAccessor accessor (e.g. getter, setter, predicate &c.). if
 * an optimized entersub finds itself invoking a function other than the
 * specific XSUB it's tailored for, then the entersub optimization is disabled.
 * This also applies if a method is redefined so that an optimized
 * entersub is passed a different type of CV than the one it's optimized for.
 *
 * The first case is detected inside the _init accessor. The second case is detected inside
 * the optimized entersub.
 *
 * In the second case, we reinstate the previous entersub, which by 1) was perl's pp_entersub.
 * In both cases, we flip a switch on the OP which ensures the *_init XSUB (if ever called again)
 * doesn't try to reinstate the optimized entersub.
 *
 * Note: Class::XSAccessor XSUBs continue to optimize "new" call sites, regardless of what may
 * have happened to a "previous" OP or what may happen to a "subsequent" OP. Take the following
 * example:
 *
 *     1: package Example;
 *     2:
 *     3: use Class::XSAccessor { getters => 'foo' };
 *     4:
 *     5: for (1 .. 10) {
 *     6:     $self->foo();
 *     7:     $self->$_ for qw(foo bar);
 *     8:     $self->foo();
 *     9: }
 *
 * Here, line 6 is optimized as normal. Line 7 is optimized on the first call, when $_ is "foo",
 * but the optimization is disabled on the second call, when $_ is "bar", because &Example::bar
 * is not a Class::XSAccessor getter. All subsequent calls on line 7, use perl's default entersub.
 * Line 8 is optimized as normal. i.e. the disabled optimization on line 7 doesn't affect subsequent
 * optimizations. On line 7, only the entersub OP is "pessimized". &Example::foo continues to "look for"
 * "new" entersub OPs to optimize. Indeed, any calls to &Example::foo will get the optimization treatment,
 * even call sites outside the Example package/file.
 *
 * The following CXAH_OPTIMIZE_ENTERSUB* macros are called from within our *_init accessors
 * to install the optimized entersub (or disable optimization for that OP). And the CXAH_GENERATE_ENTERSUB* macros
 * further down generate optimized entersubs for the accessors defined in XS/Hash.xs and XS/Array.xs.
 */

#if (PERL_BCDVERSION >= 0x5010000)
#define CXA_ENABLE_ENTERSUB_OPTIMIZATION
#endif

#ifdef CXA_ENABLE_ENTERSUB_OPTIMIZATION
#define CXA_OPTIMIZATION_OK(op) ((op->op_spare & 1) != 1)
#define CXA_DISABLE_OPTIMIZATION(op) (op->op_spare |= 1)

#define CXAH_OPTIMIZE_ENTERSUB_TEST(name)                                          \
STMT_START {                                                                       \
    /* print op_spare so that we get failing tests if perl starts using it */      \
    warn("cxah: accessor: op_spare: %03b\n", PL_op->op_spare);                     \
                                                                                   \
    if (CXA_OPTIMIZATION_OK(PL_op)) {                                              \
        if (PL_op->op_ppaddr == CXA_DEFAULT_ENTERSUB) {                            \
            warn("cxah: accessor: optimizing entersub");                           \
            PL_op->op_ppaddr = cxah_entersub_ ## name;                             \
        } else {                                                                   \
            warn("cxah: accessor: bad entersub: disabling optimization");          \
            CXA_DISABLE_OPTIMIZATION(PL_op);                                       \
        }                                                                          \
    } else {                                                                       \
        warn("cxah: accessor: entersub optimization has been disabled");           \
    }                                                                              \
} STMT_END

#define CXAH_OPTIMIZE_ENTERSUB(name)                                               \
STMT_START {                                                                       \
    if (CXA_OPTIMIZATION_OK(PL_op)) {                                              \
        if (PL_op->op_ppaddr == CXA_DEFAULT_ENTERSUB) {                            \
            PL_op->op_ppaddr = cxah_entersub_ ## name;                             \
        } else {                                                                   \
            CXA_DISABLE_OPTIMIZATION(PL_op);                                       \
        }                                                                          \
    }                                                                              \
} STMT_END

#define CXAA_OPTIMIZE_ENTERSUB(name)                                               \
STMT_START {                                                                       \
    if (CXA_OPTIMIZATION_OK(PL_op)) {                                              \
        if (PL_op->op_ppaddr == CXA_DEFAULT_ENTERSUB) {                            \
            PL_op->op_ppaddr = cxaa_entersub_ ## name;                             \
        } else {                                                                   \
            CXA_DISABLE_OPTIMIZATION(PL_op);                                       \
        }                                                                          \
    }                                                                              \
} STMT_END
#else /* CXA_ENABLE_ENTERSUB_OPTIMIZATION */
#define CXAH_OPTIMIZE_ENTERSUB_TEST(name)
#define CXAH_OPTIMIZE_ENTERSUB(name)
#define CXAA_OPTIMIZE_ENTERSUB(name)
#define CXAH_GENERATE_ENTERSUB_TEST(name)
#define CXAH_GENERATE_ENTERSUB(name)
#define CXAA_GENERATE_ENTERSUB(name)
#endif

/*
 * VMS mangles XSUB names so that they're less than 32 characters, and
 * ExtUtils::ParseXS provides no way to XS-ify XSUB names that appear
 * anywhere else but in the XSUB definition.
 *
 * The mangling is deterministic, so we can translate from every other
 * platform => VMS here
 *
 * This will probably never get used.
 */

/* FIXME: redo this to include new names */
#ifdef VMS
#define Class__XSAccessor_getter_init Class_XSAccessor_getter_init
#define Class__XSAccessor_setter_init Class_XSAccessor_setter_init
#define Class__XSAccessor_chained_setter_init Cs_XSAs_cid_ser_init
#define Class__XSAccessor_chained_setter Clas_XSAcesor_chained_seter
#define Class__XSAccessor_accessor_init Clas_XSAcesor_acesor_init
#define Class__XSAccessor_chained_accessor_init Cs_XSAs_cid_as_init
#define Class__XSAccessor_chained_accessor Clas_XSAcesor_chained_acesor
#define Class__XSAccessor_predicate_init Clas_XSAcesor_predicate_init
#define Class__XSAccessor_constructor_init Cs_XSAs_csuor_init
#define Class__XSAccessor_constructor Class_XSAccessor_constructor
#define Class__XSAccessor_constant_false_init Cs_XSAs_csnt_fse_init
#define Class__XSAccessor_constant_false Clas_XSAcesor_constant_false
#define Class__XSAccessor_constant_true_init Cs_XSAs_csnt_te_init
#define Class__XSAccessor_constant_true Clas_XSAcesor_constant_true
#define Class__XSAccessor__Array_getter_init Cs_XSAs_Ay_ger_init
#define Class__XSAccessor__Array_getter Clas_XSAcesor_Aray_geter
#define Class__XSAccessor__Array_setter_init Cs_XSAs_Ay_ser_init
#define Class__XSAccessor__Array_setter Clas_XSAcesor_Aray_seter
#define Class__XSAccessor__Array_chained_setter_init Cs_XSAs_Ay_cid_ser_init
#define Class__XSAccessor__Array_chained_setter Cs_XSAs_Ay_cid_seter
#define Class__XSAccessor__Array_accessor_init Cs_XSAs_Ay_as_init
#define Class__XSAccessor__Array_accessor Clas_XSAcesor_Aray_acesor
#define Class__XSAccessor__Array_chained_accessor_init Cs_XSAs_Ay_cid_as_init
#define Class__XSAccessor__Array_chained_accessor Cs_XSAs_Ay_cid_acesor
#define Class__XSAccessor__Array_predicate_init Cs_XSAs_Ay_pda_init
#define Class__XSAccessor__Array_predicate Clas_XSAcesor_Aray_predicate
#define Class__XSAccessor__Array_constructor_init Cs_XSAs_Ay_csuor_init
#define Class__XSAccessor__Array_constructor Cs_XSAs_Ay_constructor
#endif

#ifdef CXA_ENABLE_ENTERSUB_OPTIMIZATION
#define CXAH_GENERATE_ENTERSUB_TEST(name)                                        \
OP * cxah_entersub_ ## name(pTHX) {                                              \
    dVAR; dSP; dTOPss;                                                           \
    warn("cxah: entersub: inside optimized entersub");                           \
                                                                                 \
    if (sv                                                                       \
        && (SvTYPE(sv) == SVt_PVCV)                                              \
        && (CvXSUB((CV *)sv) == CXAH(name ## _init))                             \
    ) {                                                                          \
        (void)POPs;                                                              \
        PUTBACK;                                                                 \
        (void)CXAH(name)(aTHX_ (CV *)sv);                                        \
        return NORMAL;                                                           \
    } else { /* not static: disable optimization */                              \
        if (!sv) {                                                               \
            warn("cxah: entersub: disabling optimization: sv not defined");      \
        } else if (SvTYPE(sv) != SVt_PVCV) {                                     \
            warn("cxah: entersub: disabling optimization: sv is not a CV");      \
        } else {                                                                 \
            warn("cxah: entersub: disabling optimization: CV is not " # name);   \
        }                                                                        \
        CXA_DISABLE_OPTIMIZATION(PL_op); /* make sure it's not reinstated */     \
        PL_op->op_ppaddr = CXA_DEFAULT_ENTERSUB;                                 \
        return CALL_FPTR(CXA_DEFAULT_ENTERSUB)(aTHX);                            \
    }                                                                            \
}

#define CXAH_GENERATE_ENTERSUB(name)                                                    \
OP * cxah_entersub_ ## name(pTHX) {                                                     \
    dVAR; dSP; dTOPss;                                                                  \
                                                                                        \
    if (sv                                                                              \
        && (SvTYPE(sv) == SVt_PVCV)                                                     \
        && (CvXSUB((CV *)sv) == CXAH(name ## _init))                                    \
    ) {                                                                                 \
        (void)POPs;                                                                     \
        PUTBACK;                                                                        \
        (void)CXAH(name)(aTHX_ (CV *)sv);                                               \
        return NORMAL;                                                                  \
    } else { /* not static: disable optimization */                                     \
        CXA_DISABLE_OPTIMIZATION(PL_op); /* make sure it's not reinstated */            \
        PL_op->op_ppaddr = CXA_DEFAULT_ENTERSUB;                                        \
        return CALL_FPTR(CXA_DEFAULT_ENTERSUB)(aTHX);                                   \
    }                                                                                   \
}

#define CXAA_GENERATE_ENTERSUB(name)                                                    \
OP * cxaa_entersub_ ## name(pTHX) {                                                     \
    dVAR; dSP; dTOPss;                                                                  \
                                                                                        \
    if (sv                                                                              \
        && (SvTYPE(sv) == SVt_PVCV)                                                     \
        && (CvXSUB((CV *)sv) == CXAA(name ## _init))                                    \
    ) {                                                                                 \
        (void)POPs;                                                                     \
        PUTBACK;                                                                        \
        (void)CXAA(name)(aTHX_ (CV *)sv);                                               \
        return NORMAL;                                                                  \
    } else { /* not static: disable optimization */                                     \
        CXA_DISABLE_OPTIMIZATION(PL_op); /* make sure it's not reinstated */            \
        PL_op->op_ppaddr = CXA_DEFAULT_ENTERSUB;                                        \
        return CALL_FPTR(CXA_DEFAULT_ENTERSUB)(aTHX);                                   \
    }                                                                                   \
}
#endif /* CXA_ENABLE_ENTERSUB_OPTIMIZATION */

/* Install a new XSUB under 'name' and automatically set the file name */
#define INSTALL_NEW_CV(name, xsub)                                            \
STMT_START {                                                                  \
  if (newXS(name, xsub, (char*)__FILE__) == NULL)                             \
    croak("ARG! Something went really wrong while installing a new XSUB!");   \
} STMT_END

/* Install a new XSUB under 'name' and set the function index attribute
 * Requires a previous declaration of a CV* cv!
 **/
#define INSTALL_NEW_CV_WITH_INDEX(name, xsub, function_index)               \
STMT_START {                                                                \
  CV* cv = newXS(name, xsub, (char*)__FILE__);                              \
  if (cv == NULL)                                                           \
    croak("ARG! Something went really wrong while installing a new XSUB!"); \
  XSANY.any_i32 = function_index;                                           \
} STMT_END

/* Install a new XSUB under 'name' and set the function index attribute
 * for array-based objects. Requires a previous declaration of a CV* cv!
 **/
#define INSTALL_NEW_CV_ARRAY_OBJ(name, xsub, obj_array_index)                \
STMT_START {                                                                 \
  const U32 function_index = get_internal_array_index((I32)obj_array_index); \
  INSTALL_NEW_CV_WITH_INDEX(name, xsub, function_index);                     \
  CXSAccessor_arrayindices[function_index] = obj_array_index;                \
} STMT_END


/* Install a new XSUB under 'name' and set the function index attribute
 * for hash-based objects. Requires a previous declaration of a CV* cv!
 **/
#define INSTALL_NEW_CV_HASH_OBJ(name, xsub, obj_hash_key)                    \
STMT_START {                                                                 \
  autoxs_hashkey hashkey;                                                    \
  const U32 key_len = strlen(obj_hash_key);                                  \
  const U32 function_index = get_hashkey_index(aTHX_ obj_hash_key, key_len); \
  INSTALL_NEW_CV_WITH_INDEX(name, xsub, function_index);                     \
  Newx(hashkey.key, key_len+1, char);                                        \
  Copy(obj_hash_key, hashkey.key, key_len, char);                            \
  hashkey.key[key_len] = 0;                                                  \
  hashkey.len = key_len;                                                     \
  PERL_HASH(hashkey.hash, obj_hash_key, key_len);                            \
  CXSAccessor_hashkeys[function_index] = hashkey;                            \
} STMT_END

#ifdef CXA_ENABLE_ENTERSUB_OPTIMIZATION
static Perl_ppaddr_t CXA_DEFAULT_ENTERSUB = NULL;

/* predeclare the XSUBs so we can refer to them in the optimized entersubs */

XS(CXAH(getter));
XS(CXAH(getter_init));
CXAH_GENERATE_ENTERSUB(getter);

XS(CXAH(setter));
XS(CXAH(setter_init));
CXAH_GENERATE_ENTERSUB(setter);

XS(CXAH(chained_setter));
XS(CXAH(chained_setter_init));
CXAH_GENERATE_ENTERSUB(chained_setter);

XS(CXAH(accessor));
XS(CXAH(accessor_init));
CXAH_GENERATE_ENTERSUB(accessor);

XS(CXAH(chained_accessor));
XS(CXAH(chained_accessor_init));
CXAH_GENERATE_ENTERSUB(chained_accessor);

XS(CXAH(predicate));
XS(CXAH(predicate_init));
CXAH_GENERATE_ENTERSUB(predicate);

XS(CXAH(constructor));
XS(CXAH(constructor_init));
CXAH_GENERATE_ENTERSUB(constructor);

XS(CXAH(constant_false));
XS(CXAH(constant_false_init));
CXAH_GENERATE_ENTERSUB(constant_false);

XS(CXAH(constant_true));
XS(CXAH(constant_true_init));
CXAH_GENERATE_ENTERSUB(constant_true);

XS(CXAH(test));
XS(CXAH(test_init));
CXAH_GENERATE_ENTERSUB_TEST(test);

XS(CXAA(getter));
XS(CXAA(getter_init));
CXAA_GENERATE_ENTERSUB(getter);

XS(CXAA(setter));
XS(CXAA(setter_init));
CXAA_GENERATE_ENTERSUB(setter);

XS(CXAA(chained_setter));
XS(CXAA(chained_setter_init));
CXAA_GENERATE_ENTERSUB(chained_setter);

XS(CXAA(accessor));
XS(CXAA(accessor_init));
CXAA_GENERATE_ENTERSUB(accessor);

XS(CXAA(chained_accessor));
XS(CXAA(chained_accessor_init));
CXAA_GENERATE_ENTERSUB(chained_accessor);

XS(CXAA(predicate));
XS(CXAA(predicate_init));
CXAA_GENERATE_ENTERSUB(predicate);

XS(CXAA(constructor));
XS(CXAA(constructor_init));
CXAA_GENERATE_ENTERSUB(constructor);

#endif /* CXA_ENABLE_ENTERSUB_OPTIMIZATION */

#line 481 "XSAccessor.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

#line 524 "XSAccessor.c"

XS(XS_Class__XSAccessor_END); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_END)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 499 "XSAccessor.xs"
        if (CXSAccessor_reverse_hashkeys) {
            CXSA_HashTable_free(CXSAccessor_reverse_hashkeys);
        }
#line 541 "XSAccessor.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Class__XSAccessor___entersub_optimized__); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor___entersub_optimized__)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 507 "XSAccessor.xs"
#ifdef CXA_ENABLE_ENTERSUB_OPTIMIZATION
        XSRETURN(1);
#else
        XSRETURN(0);
#endif
#line 564 "XSAccessor.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including 'XS/Hash.xs' from 'XSAccessor.xs' */

#ifdef hv_common_key_len
#define CXSA_HASH_FETCH(hv, key, len, hash) hv_common_key_len((hv), (key), (len), HV_FETCH_JUST_SV, NULL, (hash))
#else
#define CXSA_HASH_FETCH(hv, key, len, hash) hv_fetch(hv, key, len, 0)
#endif

XS(XS_Class__XSAccessor_getter_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_getter_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 17 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 599 "XSAccessor.c"
#line 23 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    CXAH_OPTIMIZE_ENTERSUB(getter);
    if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
      PUSHs(*he);
    else
      XSRETURN_UNDEF;
#line 607 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_getter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_getter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 35 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 635 "XSAccessor.c"
#line 41 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
      PUSHs(*he);
    else
      XSRETURN_UNDEF;
#line 642 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_setter_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_setter_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 53 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
#line 670 "XSAccessor.c"
#line 58 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    CXAH_OPTIMIZE_ENTERSUB(setter);
    if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
      croak("Failed to write new value to hash.");
    PUSHs(newvalue);
#line 677 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_setter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_setter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 70 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
#line 705 "XSAccessor.c"
#line 75 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
      croak("Failed to write new value to hash.");
    PUSHs(newvalue);
#line 711 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_chained_setter_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_chained_setter_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 86 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
#line 739 "XSAccessor.c"
#line 91 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    CXAH_OPTIMIZE_ENTERSUB(chained_setter);
    if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
      croak("Failed to write new value to hash.");
    PUSHs(self);
#line 746 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_chained_setter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_chained_setter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 103 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
#line 774 "XSAccessor.c"
#line 108 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
      croak("Failed to write new value to hash.");
    PUSHs(self);
#line 780 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_accessor_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_accessor_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 118 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 808 "XSAccessor.c"
#line 124 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    CXAH_OPTIMIZE_ENTERSUB(accessor);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
        croak("Failed to write new value to hash.");
      PUSHs(newvalue);
    }
    else {
      if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
        PUSHs(*he);
      else
        XSRETURN_UNDEF;
    }
#line 824 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 144 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 852 "XSAccessor.c"
#line 150 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
        croak("Failed to write new value to hash.");
      PUSHs(newvalue);
    }
    else {
      if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
        PUSHs(*he);
      else
        XSRETURN_UNDEF;
    }
#line 867 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_chained_accessor_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_chained_accessor_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 169 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 895 "XSAccessor.c"
#line 175 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    CXAH_OPTIMIZE_ENTERSUB(chained_accessor);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
        croak("Failed to write new value to hash.");
      PUSHs(self);
    }
    else {
      if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
        PUSHs(*he);
      else
        XSRETURN_UNDEF;
    }
#line 911 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_chained_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_chained_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 195 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 939 "XSAccessor.c"
#line 201 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
        croak("Failed to write new value to hash.");
      PUSHs(self);
    }
    else {
      if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
        PUSHs(*he);
      else
        XSRETURN_UNDEF;
    }
#line 954 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_predicate_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_predicate_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 220 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 982 "XSAccessor.c"
#line 226 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    CXAH_OPTIMIZE_ENTERSUB(predicate);
    if ( ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash))) && SvOK(*he) )
       XSRETURN_YES;
    else
      XSRETURN_NO;
#line 990 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_predicate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_predicate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 238 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 1018 "XSAccessor.c"
#line 244 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    if ( ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash))) && SvOK(*he) )
       XSRETURN_YES;
    else
      XSRETURN_NO;
#line 1025 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_constructor_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_constructor_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	class = ST(0);
#line 254 "XS/Hash.xs"
    int iStack;
    HV* hash;
    SV* obj;
    const char* classname;
#line 1051 "XSAccessor.c"
#line 259 "XS/Hash.xs"
    CXAH_OPTIMIZE_ENTERSUB(constructor);
    if (sv_isobject(class)) {
      classname = sv_reftype(SvRV(class), 1);
    }
    else {
      if (!SvPOK(class))
        croak("Need an object or class name as first argument to the constructor.");
      classname = SvPV_nolen(class);
    }

    hash = (HV *)sv_2mortal((SV *)newHV());
    obj = sv_bless( newRV_inc((SV*)hash), gv_stashpv(classname, 1) );

    if (items > 1) {
      if (!(items % 2))
        croak("Uneven number of arguments to constructor.");

      for (iStack = 1; iStack < items; iStack += 2) {
        HE *he;
        he = hv_store_ent(hash, ST(iStack), newSVsv(ST(iStack+1)), 0);
        if (!he) {
          croak("Failed to write value to hash.");
        }
      }
    }
    PUSHs(sv_2mortal(obj));
#line 1079 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_constructor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_constructor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	class = ST(0);
#line 290 "XS/Hash.xs"
    int iStack;
    HV* hash;
    SV* obj;
    const char* classname;
#line 1105 "XSAccessor.c"
#line 295 "XS/Hash.xs"
    if (sv_isobject(class)) {
      classname = sv_reftype(SvRV(class), 1);
    }
    else {
      if (!SvPOK(class))
        croak("Need an object or class name as first argument to the constructor.");
      classname = SvPV_nolen(class);
    }

    hash = (HV *)sv_2mortal((SV *)newHV());
    obj = sv_bless( newRV_inc((SV*)hash), gv_stashpv(classname, 1) );

    if (items > 1) {
      if (!(items % 2))
        croak("Uneven number of arguments to constructor.");

      for (iStack = 1; iStack < items; iStack += 2) {
        HE *he;
        he = hv_store_ent(hash, ST(iStack), newSVsv(ST(iStack+1)), 0);
        if (!he) {
          croak("Failed to write value to hash.");
        }
      }
    }
    PUSHs(sv_2mortal(obj));
#line 1132 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_constant_false_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_constant_false_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0);
#line 325 "XS/Hash.xs"
    PERL_UNUSED_VAR(self);
    CXAH_OPTIMIZE_ENTERSUB(constant_false);
    {
      XSRETURN_NO;
    }
#line 1159 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_constant_false); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_constant_false)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	self = ST(0);
#line 335 "XS/Hash.xs"
    PERL_UNUSED_VAR(self);
    {
      XSRETURN_NO;
    }
#line 1185 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_constant_true_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_constant_true_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 344 "XS/Hash.xs"
    PERL_UNUSED_VAR(self);
    CXAH_OPTIMIZE_ENTERSUB(constant_true);
    {
      XSRETURN_YES;
    }
#line 1212 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_constant_true); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_constant_true)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 354 "XS/Hash.xs"
    PERL_UNUSED_VAR(self);
    {
      XSRETURN_YES;
    }
#line 1238 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_test_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_test_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 364 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 1266 "XSAccessor.c"
#line 370 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    warn("cxah: accessor: inside test_init");
    CXAH_OPTIMIZE_ENTERSUB_TEST(test);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
        croak("Failed to write new value to hash.");
      PUSHs(newvalue);
    }
    else {
      if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
        PUSHs(*he);
      else
        XSRETURN_UNDEF;
    }
#line 1283 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_test); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_test)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 391 "XS/Hash.xs"
    /* Get the const hash key struct from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const autoxs_hashkey readfrom = CXSAccessor_hashkeys[ix];
    SV** he;
#line 1311 "XSAccessor.c"
#line 397 "XS/Hash.xs"
    CXA_CHECK_HASH(self);
    warn("cxah: accessor: inside test");
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == hv_store((HV*)SvRV(self), readfrom.key, readfrom.len, newSVsv(newvalue), readfrom.hash))
        croak("Failed to write new value to hash.");
      PUSHs(newvalue);
    }
    else {
      if ((he = CXSA_HASH_FETCH((HV *)SvRV(self), readfrom.key, readfrom.len, readfrom.hash)))
        PUSHs(*he);
      else
        XSRETURN_UNDEF;
    }
#line 1327 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_getter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_getter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	char*	key = (char *)SvPV_nolen(ST(1));
#line 417 "XS/Hash.xs"
    INSTALL_NEW_CV_HASH_OBJ(name, CXAH(getter_init), key);
#line 1351 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_setter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_setter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "name, key, chained");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	char*	key = (char *)SvPV_nolen(ST(1));
	bool	chained = (bool)SvTRUE(ST(2));
#line 425 "XS/Hash.xs"
    if (chained)
      INSTALL_NEW_CV_HASH_OBJ(name, CXAH(chained_setter_init), key);
    else
      INSTALL_NEW_CV_HASH_OBJ(name, CXAH(setter_init), key);
#line 1379 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "name, key, chained");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	char*	key = (char *)SvPV_nolen(ST(1));
	bool	chained = (bool)SvTRUE(ST(2));
#line 436 "XS/Hash.xs"
    if (chained)
      INSTALL_NEW_CV_HASH_OBJ(name, CXAH(chained_accessor_init), key);
    else
      INSTALL_NEW_CV_HASH_OBJ(name, CXAH(accessor_init), key);
#line 1407 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_predicate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_predicate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	char*	key = (char *)SvPV_nolen(ST(1));
#line 446 "XS/Hash.xs"
    INSTALL_NEW_CV_HASH_OBJ(name, CXAH(predicate_init), key);
#line 1431 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_constructor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_constructor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
#line 452 "XS/Hash.xs"
    INSTALL_NEW_CV(name, CXAH(constructor_init));
#line 1454 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_boolean); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_boolean)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, truth");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	bool	truth = (bool)SvTRUE(ST(1));
#line 459 "XS/Hash.xs"
    if (truth)
      INSTALL_NEW_CV(name, CXAH(constant_true_init));
    else
      INSTALL_NEW_CV(name, CXAH(constant_false_init));
#line 1481 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor_newxs_test); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor_newxs_test)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, key");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	char*	key = (char *)SvPV_nolen(ST(1));
#line 469 "XS/Hash.xs"
      INSTALL_NEW_CV_HASH_OBJ(name, CXAH(test_init), key);
#line 1505 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'XSAccessor.xs' from 'XS/Hash.xs' */


/* INCLUDE:  Including 'XS/Array.xs' from 'XSAccessor.xs' */


XS(XS_Class__XSAccessor__Array_getter_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_getter_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 9 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1539 "XSAccessor.c"
#line 15 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    CXAA_OPTIMIZE_ENTERSUB(getter);
    if ((elem = av_fetch((AV *)SvRV(self), index, 1)))
      PUSHs(elem[0]);
    else
      XSRETURN_UNDEF;
#line 1547 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_getter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_getter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 27 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1575 "XSAccessor.c"
#line 33 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    if ((elem = av_fetch((AV *)SvRV(self), index, 1)))
      PUSHs(elem[0]);
    else
      XSRETURN_UNDEF;
#line 1582 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_setter_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_setter_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 45 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
#line 1610 "XSAccessor.c"
#line 50 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    CXAA_OPTIMIZE_ENTERSUB(setter);
    if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
      croak("Failed to write new value to array.");
    PUSHs(newvalue);
#line 1617 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_setter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_setter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 62 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
#line 1645 "XSAccessor.c"
#line 67 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
      croak("Failed to write new value to array.");
    PUSHs(newvalue);
#line 1651 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_chained_setter_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_chained_setter_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 78 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
#line 1679 "XSAccessor.c"
#line 83 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    CXAA_OPTIMIZE_ENTERSUB(chained_setter);
    if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
      croak("Failed to write new value to array.");
    PUSHs(self);
#line 1686 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_chained_setter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_chained_setter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, newvalue");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
	SV*	newvalue = ST(1);
#line 95 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
#line 1714 "XSAccessor.c"
#line 100 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
      croak("Failed to write new value to array.");
    PUSHs(self);
#line 1720 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_accessor_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_accessor_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 110 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1748 "XSAccessor.c"
#line 116 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    CXAA_OPTIMIZE_ENTERSUB(accessor);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
        croak("Failed to write new value to array.");
      PUSHs(newvalue);
    }
    else {
      if ((elem = av_fetch((AV *)SvRV(self), index, 1)))
        PUSHs(elem[0]);
      else
        XSRETURN_UNDEF;
    }
#line 1764 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 136 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1792 "XSAccessor.c"
#line 142 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
        croak("Failed to write new value to array.");
      PUSHs(newvalue);
    }
    else {
      if ((elem = av_fetch((AV *)SvRV(self), index, 1)))
        PUSHs(elem[0]);
      else
        XSRETURN_UNDEF;
    }
#line 1807 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_chained_accessor_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_chained_accessor_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 161 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1835 "XSAccessor.c"
#line 167 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    CXAA_OPTIMIZE_ENTERSUB(chained_accessor);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
        croak("Failed to write new value to array.");
      PUSHs(self);
    }
    else {
      if ((elem = av_fetch((AV *)SvRV(self), index, 1)))
        PUSHs(elem[0]);
      else
        XSRETURN_UNDEF;
    }
#line 1851 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_chained_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_chained_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 187 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1879 "XSAccessor.c"
#line 193 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    if (items > 1) {
      SV* newvalue = ST(1);
      if (NULL == av_store((AV*)SvRV(self), index, newSVsv(newvalue)))
        croak("Failed to write new value to array.");
      PUSHs(self);
    }
    else {
      if ((elem = av_fetch((AV *)SvRV(self), index, 1)))
        PUSHs(elem[0]);
      else
        XSRETURN_UNDEF;
    }
#line 1894 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_predicate_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_predicate_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 212 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1922 "XSAccessor.c"
#line 218 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    CXAA_OPTIMIZE_ENTERSUB(predicate);
    if ( (elem = av_fetch((AV *)SvRV(self), index, 1)) && SvOK(elem[0]) )
      XSRETURN_YES;
    else
      XSRETURN_NO;
#line 1930 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_predicate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_predicate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	self = ST(0);
#line 230 "XS/Array.xs"
    /* Get the array index from the global storage */
    /* ix is the magic integer variable that is set by the perl guts for us.
     * We uses it to identify the currently running alias of the accessor. Gollum! */
    const I32 index = CXSAccessor_arrayindices[ix];
    SV** elem;
#line 1958 "XSAccessor.c"
#line 236 "XS/Array.xs"
    CXA_CHECK_ARRAY(self);
    if ( (elem = av_fetch((AV *)SvRV(self), index, 1)) && SvOK(elem[0]) )
      XSRETURN_YES;
    else
      XSRETURN_NO;
#line 1965 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_constructor_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_constructor_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	class = ST(0);
#line 246 "XS/Array.xs"
    AV* array;
    SV* obj;
    const char* classname;
#line 1990 "XSAccessor.c"
#line 250 "XS/Array.xs"
    CXAA_OPTIMIZE_ENTERSUB(constructor);
    if (sv_isobject(class)) {
      classname = sv_reftype(SvRV(class), 1);
    }
    else {
      if (!SvPOK(class))
        croak("Need an object or class name as first argument to the constructor.");
      classname = SvPV_nolen(class);
    }

    array = (AV *)sv_2mortal((SV *)newAV());
    obj = sv_bless( newRV_inc((SV*)array), gv_stashpv(classname, 1) );

    /* we ignore arguments. See Class::XSAccessor's XS code for
     * how we'd use them in case of bless {@_} => $class.
     */
    PUSHs(sv_2mortal(obj));
#line 2009 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_constructor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_constructor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "class, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	class = ST(0);
#line 272 "XS/Array.xs"
    AV* array;
    SV* obj;
    const char* classname;
#line 2034 "XSAccessor.c"
#line 276 "XS/Array.xs"
    if (sv_isobject(class)) {
      classname = sv_reftype(SvRV(class), 1);
    }
    else {
      if (!SvPOK(class))
        croak("Need an object or class name as first argument to the constructor.");
      classname = SvPV_nolen(class);
    }

    array = (AV *)sv_2mortal((SV *)newAV());
    obj = sv_bless( newRV_inc((SV*)array), gv_stashpv(classname, 1) );

    /* we ignore arguments. See Class::XSAccessor's XS code for
     * how we'd use them in case of bless {@_} => $class.
     */
    PUSHs(sv_2mortal(obj));
#line 2052 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_newxs_getter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_newxs_getter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, index");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	U32	index = (unsigned long)SvUV(ST(1));
#line 298 "XS/Array.xs"
    INSTALL_NEW_CV_ARRAY_OBJ(name, CXAA(getter_init), index);
#line 2076 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_newxs_setter); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_newxs_setter)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "name, index, chained");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	U32	index = (unsigned long)SvUV(ST(1));
	bool	chained = (bool)SvTRUE(ST(2));
#line 307 "XS/Array.xs"
    if (chained)
      INSTALL_NEW_CV_ARRAY_OBJ(name, CXAA(chained_setter_init), index);
    else
      INSTALL_NEW_CV_ARRAY_OBJ(name, CXAA(setter_init), index);
#line 2104 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_newxs_accessor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_newxs_accessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       croak_xs_usage(cv,  "name, index, chained");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	U32	index = (unsigned long)SvUV(ST(1));
	bool	chained = (bool)SvTRUE(ST(2));
#line 318 "XS/Array.xs"
    if (chained)
      INSTALL_NEW_CV_ARRAY_OBJ(name, CXAA(chained_accessor_init), index);
    else
      INSTALL_NEW_CV_ARRAY_OBJ(name, CXAA(accessor_init), index);
#line 2132 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_newxs_predicate); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_newxs_predicate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "name, index");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
	U32	index = (unsigned long)SvUV(ST(1));
#line 328 "XS/Array.xs"
    INSTALL_NEW_CV_ARRAY_OBJ(name, CXAA(predicate_init), index);
#line 2156 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


XS(XS_Class__XSAccessor__Array_newxs_constructor); /* prototype to pass -Wmissing-prototypes */
XS(XS_Class__XSAccessor__Array_newxs_constructor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char*	name = (char *)SvPV_nolen(ST(0));
#line 334 "XS/Array.xs"
    INSTALL_NEW_CV(name, CXAA(constructor_init));
#line 2179 "XSAccessor.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'XSAccessor.xs' from 'XS/Array.xs' */

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Class__XSAccessor); /* prototype to pass -Wmissing-prototypes */
XS(boot_Class__XSAccessor)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    const char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXSproto("Class::XSAccessor::END", XS_Class__XSAccessor_END, file, "");
        newXSproto("Class::XSAccessor::__entersub_optimized__", XS_Class__XSAccessor___entersub_optimized__, file, "");
        newXS("Class::XSAccessor::getter_init", XS_Class__XSAccessor_getter_init, file);
        newXS("Class::XSAccessor::getter", XS_Class__XSAccessor_getter, file);
        newXS("Class::XSAccessor::setter_init", XS_Class__XSAccessor_setter_init, file);
        newXS("Class::XSAccessor::setter", XS_Class__XSAccessor_setter, file);
        newXS("Class::XSAccessor::chained_setter_init", XS_Class__XSAccessor_chained_setter_init, file);
        newXS("Class::XSAccessor::chained_setter", XS_Class__XSAccessor_chained_setter, file);
        newXS("Class::XSAccessor::accessor_init", XS_Class__XSAccessor_accessor_init, file);
        newXS("Class::XSAccessor::accessor", XS_Class__XSAccessor_accessor, file);
        newXS("Class::XSAccessor::chained_accessor_init", XS_Class__XSAccessor_chained_accessor_init, file);
        newXS("Class::XSAccessor::chained_accessor", XS_Class__XSAccessor_chained_accessor, file);
        newXS("Class::XSAccessor::predicate_init", XS_Class__XSAccessor_predicate_init, file);
        newXS("Class::XSAccessor::predicate", XS_Class__XSAccessor_predicate, file);
        newXS("Class::XSAccessor::constructor_init", XS_Class__XSAccessor_constructor_init, file);
        newXS("Class::XSAccessor::constructor", XS_Class__XSAccessor_constructor, file);
        newXS("Class::XSAccessor::constant_false_init", XS_Class__XSAccessor_constant_false_init, file);
        newXS("Class::XSAccessor::constant_false", XS_Class__XSAccessor_constant_false, file);
        newXS("Class::XSAccessor::constant_true_init", XS_Class__XSAccessor_constant_true_init, file);
        newXS("Class::XSAccessor::constant_true", XS_Class__XSAccessor_constant_true, file);
        newXS("Class::XSAccessor::test_init", XS_Class__XSAccessor_test_init, file);
        newXS("Class::XSAccessor::test", XS_Class__XSAccessor_test, file);
        newXS("Class::XSAccessor::newxs_getter", XS_Class__XSAccessor_newxs_getter, file);
        newXS("Class::XSAccessor::newxs_setter", XS_Class__XSAccessor_newxs_setter, file);
        newXS("Class::XSAccessor::newxs_accessor", XS_Class__XSAccessor_newxs_accessor, file);
        newXS("Class::XSAccessor::newxs_predicate", XS_Class__XSAccessor_newxs_predicate, file);
        newXS("Class::XSAccessor::newxs_constructor", XS_Class__XSAccessor_newxs_constructor, file);
        newXS("Class::XSAccessor::newxs_boolean", XS_Class__XSAccessor_newxs_boolean, file);
        newXS("Class::XSAccessor::newxs_test", XS_Class__XSAccessor_newxs_test, file);
        newXS("Class::XSAccessor::Array::getter_init", XS_Class__XSAccessor__Array_getter_init, file);
        newXS("Class::XSAccessor::Array::getter", XS_Class__XSAccessor__Array_getter, file);
        newXS("Class::XSAccessor::Array::setter_init", XS_Class__XSAccessor__Array_setter_init, file);
        newXS("Class::XSAccessor::Array::setter", XS_Class__XSAccessor__Array_setter, file);
        newXS("Class::XSAccessor::Array::chained_setter_init", XS_Class__XSAccessor__Array_chained_setter_init, file);
        newXS("Class::XSAccessor::Array::chained_setter", XS_Class__XSAccessor__Array_chained_setter, file);
        newXS("Class::XSAccessor::Array::accessor_init", XS_Class__XSAccessor__Array_accessor_init, file);
        newXS("Class::XSAccessor::Array::accessor", XS_Class__XSAccessor__Array_accessor, file);
        newXS("Class::XSAccessor::Array::chained_accessor_init", XS_Class__XSAccessor__Array_chained_accessor_init, file);
        newXS("Class::XSAccessor::Array::chained_accessor", XS_Class__XSAccessor__Array_chained_accessor, file);
        newXS("Class::XSAccessor::Array::predicate_init", XS_Class__XSAccessor__Array_predicate_init, file);
        newXS("Class::XSAccessor::Array::predicate", XS_Class__XSAccessor__Array_predicate, file);
        newXS("Class::XSAccessor::Array::constructor_init", XS_Class__XSAccessor__Array_constructor_init, file);
        newXS("Class::XSAccessor::Array::constructor", XS_Class__XSAccessor__Array_constructor, file);
        newXS("Class::XSAccessor::Array::newxs_getter", XS_Class__XSAccessor__Array_newxs_getter, file);
        newXS("Class::XSAccessor::Array::newxs_setter", XS_Class__XSAccessor__Array_newxs_setter, file);
        newXS("Class::XSAccessor::Array::newxs_accessor", XS_Class__XSAccessor__Array_newxs_accessor, file);
        newXS("Class::XSAccessor::Array::newxs_predicate", XS_Class__XSAccessor__Array_newxs_predicate, file);
        newXS("Class::XSAccessor::Array::newxs_constructor", XS_Class__XSAccessor__Array_newxs_constructor, file);

    /* Initialisation Section */

#line 475 "XSAccessor.xs"
#ifdef CXA_ENABLE_ENTERSUB_OPTIMIZATION
CXA_DEFAULT_ENTERSUB = PL_ppaddr[OP_ENTERSUB];
#endif
#ifdef USE_ITHREADS
_init_cxsa_lock(&CXSAccessor_lock); /* cf. CXSAccessor.h */
#endif /* USE_ITHREADS */
/*
 * testing the hashtable implementation...
 */
/*
{
  HashTable* tb = CXSA_HashTable_new(16, 0.9);
  CXSA_HashTable_store(tb, "test", 4, 12);
  CXSA_HashTable_store(tb, "test5", 5, 199);
  warn("12==%u\n", CXSA_HashTable_fetch(tb, "test", 4));
  warn("199==%u\n", CXSA_HashTable_fetch(tb, "test5", 5));
  warn("0==%u\n", CXSA_HashTable_fetch(tb, "test123", 7));
}
*/

#line 2277 "XSAccessor.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

